
local importPath=string.gsub(getfenv(1)._.Name,"%.TMSearch","").."."
local resourcePath=string.gsub(importPath,"%.","/").."Resources/"
-- This plugin gets it's parameters from the "0TMP_" command (registered by TerrainMap before this plugin is loaded)
-- this plugin then processes each map's data file, searching for the parameter and creating a "0TMR_" result command for each match
-- once done, it creates the "0TMC" command which causes TerrainMap to process and "0TMR_" commands and then unload this plugin
-- in this plugin's unload, the "0TMR_" commands and "0TMC" are removed since TerrainMap processes them before unloading this plugin

import (importPath.."Class");
import (importPath.."Table");

import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";

local cmdCount=0
local parms
local cmds=Turbine.Shell.GetCommands();
if cmds~=nil and type(cmds)=="table" then
	table.sort(cmds,function(arg1,arg2)if arg1<arg2 then return(true) end end);
	for cmdIndex=0,#cmds do
		if cmds[cmdIndex]~=nil then
			if cmdIndex>1 and cmds[cmdIndex]>="1" then
				break
			else
				parms=string.match(cmds[cmdIndex],"0TMP_(.*)");
				if parms~=nil then
					break
				end
			end
		end
	end
end
if parms==nil then
	a[1]="Do Not Load This Plugin!"
	return false;
end
_G.tmpAnnotations={}
_G.tmpMapString={}

respCmd={}
replaceStr={[128]="A",[129]="A",[130]="A",[131]="A",[132]="A",[133]="A",[134]="AE",[135]="C",[136]="E",[137]="E",[138]="E",[139]="E",[140]="I",[141]="I",[142]="I",[143]="I",[144]="",[145]="N",[146]="O",[147]="O",[148]="O",[149]="O",[150]="O",[151]="",[152]="O",[153]="U",[154]="U",[155]="U",[156]="U",[157]="Y",[158]="Y",[159]="sz",[160]="a",[161]="a",[162]="a",[163]="a",[164]="a",[165]="a",[166]="ae",[167]="c",[168]="e",[169]="e",[170]="e",[171]="e",[172]="i",[173]="i",[174]="i",[175]="i",[176]="o",[177]="n",[178]="o",[179]="o",[180]="o",[181]="o",[182]="o",[183]="",[184]="o",[185]="u",[186]="u",[187]="u",[188]="u",[189]="y",[190]="y",[191]="y"}
string.stripaccent=function(str)
	local ret = "";
	if str~=nil then
		ret=""
		local replace=false
		for i,v in ipairs({str:byte(1,-1)}) do
			if replace then
				replace=false
				if replaceStr[v]~=nil then
					ret=ret..replaceStr[v]
				end
			else
				if (v==195) then
					replace=true
				else
					ret = ret .. string.char(v);
				end
			end
		end
	end
	return ret;
end
string.split=function(str,separator)
	local tmpArray={};
	local tmpElem;
	str=tostring(str);
	if string.find("^$()%.[]*+-?",separator,1,true)~=nil then separator="%"..separator end
	for tmpElem in string.gmatch(str,"[^"..separator.."]*") do
		table.insert(tmpArray,tmpElem);
	end
	local tmpIndex=1;
	while tmpIndex<=#tmpArray do
		if tmpIndex==#tmpArray and tmpArray[tmpIndex]=="" then
			table.remove(tmpArray,tmpIndex);
		else
			if tmpArray[tmpIndex]=="" and tmpArray[tmpIndex+1]~="" then
				table.remove(tmpArray,tmpIndex);
			else
				tmpIndex=tmpIndex+1;
			end
		end
	end
	return tmpArray;
end
searchName=string.lower(string.stripaccent(parms))

	mapInfo={}
	mapInfo[1]={"Ettenmoors",1,3,nil,nil}
	mapInfo[2]={"Middle-earth",1,1,nil,nil}
	mapInfo[3]={"Eriador",1,2,nil,nil}
	mapInfo[4]={"Angmar",1,3,nil,nil}
	mapInfo[5]={"Bree-land",1,3,nil,nil}
	mapInfo[6]={"Archet",1,4,nil,nil}
	mapInfo[7]={"Barrow Downs North",1,4,nil,nil}
	mapInfo[8]={"Barrow Downs South",1,4,nil,nil}
	mapInfo[9]={"Bree",1,4,nil,nil}
	mapInfo[10]={"Breeland Homesteads",1,4,nil,nil}
	mapInfo[11]={"The Old Forest",1,4,nil,nil}
	mapInfo[12]={"Enedwaith",1,3,nil,nil}
	mapInfo[13]={"Ered Luin",1,3,nil,nil}
	mapInfo[14]={"Falathlorn Homesteads",1,4,nil,nil}
	mapInfo[15]={"Thorin's Gate",1,4,nil,nil}
	mapInfo[16]={"Thorin's Hall Homesteads",1,4,nil,nil}
	mapInfo[17]={"Eregion",1,4,nil,nil}
	mapInfo[18]={"The Walls of Moria",1,4,nil,nil}
	mapInfo[19]={"Evendim",1,3,nil,nil}
	mapInfo[20]={"Annuminas",1,4,nil,nil}
	mapInfo[21]={"Forochel",1,3,nil,nil}
	mapInfo[22]={"Frostbluff",1,3,nil,nil}
	mapInfo[23]={"Lone-lands",1,3,nil,nil}
	mapInfo[24]={"Misty Mountains",1,3,nil,nil}
	mapInfo[25]={"North Downs",1,3,nil,nil}
	mapInfo[26]={"The Shire",1,3,nil,nil}
	mapInfo[27]={"Shire Homesteads",1,4,nil,nil}
	mapInfo[28]={"Trollshaws",1,3,nil,nil}
	mapInfo[29]={"Rivendell",1,4,nil,nil}
	mapInfo[30]={"Rhovanion",2,2,nil,nil}
	mapInfo[31]={"Lothlorien",2,3,nil,nil}
	mapInfo[32]={"Caras Galadon",2,4,nil,nil}
	mapInfo[33]={"Mirkwood",2,3,nil,nil}
	mapInfo[34]={"Moria",2,3,nil,nil}
	mapInfo[35]={"Durin's Way",2,4,nil,nil}
	mapInfo[36]={"Flaming Deeps",2,4,nil,nil}
	mapInfo[37]={"Foundations of Stone",2,4,nil,nil}
	mapInfo[38]={"Nud Melek",2,4,nil,nil}
	mapInfo[39]={"Redhorn Lodes",2,4,nil,nil}
	mapInfo[40]={"The Grand Stair",2,4}
	mapInfo[41]={"The Gread Delving",2,4,nil,nil}
	mapInfo[42]={"The Silvertine Lodes",2,4,nil,nil}
	mapInfo[43]={"The Waterworks",2,4,nil,nil}
	mapInfo[44]={"Zelem Melek",2,4,nil,nil}
	mapInfo[45]={"Zirak Zigil",2,4}
	mapInfo[46]={"Thorin's Hall - Main Floor",1,5,-13.7,-103.2}
	mapInfo[47]={"Thorin's Hall - Basement",1,5,-13.7,-103.2}
	mapInfo[48]={"Delving of Fror",1,4,-16.8, -22.2}
	mapInfo[49]={"Breeland Brigand Cave",1,4,-21.3,-55.3}
	mapInfo[50]={"Rockbelly Pit",1,5,-15.7,-102.3}
	mapInfo[51]={"Sprigley's Cellar",1,5,-27.99, -48.3}
	mapInfo[52]={"Mirkstone Tunnels",1,5,-14.6, -104.9}
	mapInfo[53]={"Silver Deep",1,5,-14.3, -101.6}
	mapInfo[54]={"Skorgrim's Tomb",1,5,-15.8, -102.5}
	mapInfo[55]={"Annuminas - Haudh Valandur",1,4,-16.4, -66.5}
	mapInfo[56]={"Annuminas - Haudh E\195\164rendur",1,4,-16, -66.4}
	mapInfo[57]={"Annuminas - Haudh Eldacar",1,4,-17.2, -66.8}
	mapInfo[58]={"Annuminas - Haudh Arantar",1,4,-17.2, -66.3}
	mapInfo[59]={"Evendim - Gwindethrond",1,4,-13.7, -76}
	mapInfo[60]={"Dunlending",1,3,nil,nil}
	mapInfo[61]={"Dunland",1,4,nil,nil}
	mapInfo[62]={"Gap Of Rohan",1,4,nil,nil}
	mapInfo[63]={"Nan Curund\195\173r",1,4,nil,nil}
	mapInfo[64]={"Galtrev",1,5,nil,nil}
	mapInfo[65]={"Isengard",1,5,nil,nil}
	mapInfo[66]={"Pit of Iron",1,5,-86.1, -3.7}
	mapInfo[67]={"The Great River",2,3,nil,nil}
	mapInfo[68]={"Stangard",2,4,nil,nil}
	mapInfo[69]={"T\195\162l Methedras",1,4,nil,nil} -- after
	mapInfo[70]={"T\195\162l Methedras",1,4,nil,nil} -- before
	mapInfo[71]={"East Rohan",2,3,nil,nil}
	mapInfo[72]={"Eaves of Fangorn",2,4,nil,nil}
	mapInfo[73]={"East Wall",2,4,nil,nil}
	mapInfo[74]={"Entwash Vale",2,4,nil,nil}
	mapInfo[75]={"Norcrofts",2,4,nil,nil}
	mapInfo[76]={"Sutcrofts",2,4,nil,nil}
	mapInfo[77]={"The Wold",2,4,nil,nil}
	mapInfo[78]={"Harwick",2,5,nil,nil}
	mapInfo[79]={"Snowbourn",2,5,nil,nil}
	mapInfo[80]={"Cliving",2,5,nil,nil}
	mapInfo[81]={"Eaworth",2,5,nil,nil}
	mapInfo[82]={"Byrgenstow",2,5,-44.72, -66.47}
	mapInfo[83]={"Byrgenstow",2,5,-44.72, -66.47}
	mapInfo[84]={"Langraf",2,5}
	mapInfo[85]={"Ost Magol - Lower",2,5}
	mapInfo[86]={"Ost Magol - Upper",2,5}
	mapInfo[87]={"The Living Deep",2,5}
	mapInfo[88]={"Gerngarth - Lower",2,5}
	mapInfo[89]={"Gerngarth - Upper",2,5}
	mapInfo[90]={"Isengraf",2,5}
	mapInfo[91]={"Wyrmdelf - Lower",2,5,-45, -61.7}-- (double size)
	mapInfo[92]={"Wyrmdelf - Upper",2,5,-45, -61.7}-- (double size)
	mapInfo[93]={"Dwergfant",2,5}
	mapInfo[94]={"The Ancient Tomb",2,5}
	mapInfo[95]={"D\195\173gelon - Lower",2,5}
	mapInfo[96]={"D\195\173gelon - Middle",2,5}
	mapInfo[97]={"D\195\173gelon - Upper",2,5}
	mapInfo[98]={"The Creeping Wood",2,5}
	mapInfo[99]={"Goblintown Tunnels - South",1,4,-20.8, 6.2}
	mapInfo[100]={"Goblintown Tunnels - Central",1,4,-20.8, 6.2}
	mapInfo[101]={"Goblintown Tunnels - North",1,4,-20.8, 6.2}
	mapInfo[102]={"Goblintown Slave Pens",1,4,-20.8, 6.2}
	mapInfo[103]={"Goblintown War Steadings",1,4,-20.8, 6.2}
	mapInfo[104]={"Goblintown Thundergrot",1,4,-20.8, 6.2}
	mapInfo[105]={"Gollums Cave",1,4,-20.8, 6.2}
	mapInfo[106]={"Goblintown Throne Room",1,4,-20.8, 6.2}
	mapInfo[107]={"Parph\195\161d - Upper",2,5}
	mapInfo[108]={"Parph\195\161d - Lower",2,5}
	mapInfo[109]={"The Peaceful Path",2,5,-2.91, -107.21}
	mapInfo[110]={"Gh\195\162r-khafush",2,5,-4.34, -110.19}
	mapInfo[111]={"Buzun-gh\195\162r",2,5,-4.29, -108.56}
	mapInfo[112]={"Wildermore",2,4,nil,nil}
	mapInfo[113]={"Forlaw",2,5,nil,nil}

	mapInfo[114]={"Western Rohan",2,3,nil,nil}
	mapInfo[115]={"Kingstead",2,4,nil,nil}
	mapInfo[116]={"Broadacres",2,4,nil,nil}
	mapInfo[117]={"Eastfold",2,4,nil,nil}
	mapInfo[118]={"Stonedeans",2,4,nil,nil}
	mapInfo[119]={"Helm's Deep",2,4,nil,nil}
	mapInfo[120]={"Westfold",2,4,nil,nil}
	mapInfo[121]={"Edoras",2,5,nil,nil}

	mapInfo[122]={"Entwood",2,4,nil,nil}; -- entwood
	mapInfo[123]={"Isengard (flooded)",2,4,nil,nil}; -- isengard (flooded)
-- West Gondor
	mapInfo[124]={"Gondor",3,2,nil,nil};
	mapInfo[125]={"Western Gondor",3,3,nil,nil};
	mapInfo[126]={"Blackroot Vale",3,4,nil,nil};
	mapInfo[127]={"Havens Of Belfalas",3,4,nil,nil};
	mapInfo[128]={"Dol Amroth",3,5,nil,nil};
	mapInfo[129]={"Lamedon",3,4,nil,nil};
	mapInfo[130]={"Paths Of The Dead",3,4,nil,nil};

	mapInfo[131]={"Dead Marshes",3,3,nil,nil};
	mapInfo[132]={"Central Gondor",3,3}; -- Cental gondor
	mapInfo[133]={"Ringl\195\179 Vale",3,4}; -- Ringlo
	mapInfo[134]={"Lebennin",3,4}; -- Lebennin
	mapInfo[135]={"Pelargir",3,5}; -- Pelargir
	mapInfo[136]={"Dor-en-Ernil",3,4}; -- Dor-en-ernil
	mapInfo[137]={"Grimbeorn's House",2,3}; -- Grimbeorn's House
	mapInfo[138]={"Eastern Gondor",3,3}; -- Eastern Gondor
	mapInfo[139]={"Upper Lebennin",3,4}; -- Upper Lebennin
	mapInfo[140]={"South Ithilien",3,4}; -- South Ithilien
	mapInfo[141]={"Lossarnach",3,4}; -- Lossarnach
	mapInfo[142]={"Osgiliath",3,5}; -- Osgiliath
	mapInfo[143]={"Osgiliath (PvMP)",3,5}; -- Osgiliath (PvMP)

	mapInfo[144]={"Talath Anor",3,4}; -- Talath Anor
	mapInfo[145]={"Minas Tirith",3,5}; -- Minas Tirith
	mapInfo[146]={"Pelennor",3,4}; -- Pelennor
	mapInfo[147]={"Old An\195\179rien",3,3}; -- Old Anorien
	mapInfo[148]={"Far An\195\179rien",3,3}; -- Far Anorien
	mapInfo[149]={"Beacon Hills",3,4}; -- Beacon Hills
	mapInfo[150]={"Taur Dr\195\186adan",3,4}; -- Taur Druadan
	mapInfo[151]={"Cape of Belfalas",3,4}
	mapInfo[152]={"Mordor",4,2}
	mapInfo[153]={"Pelennor after Battle",4,5}
	mapInfo[154]={"North Ithilien",4,4}
	mapInfo[155]={"March of the King",4,3}
	mapInfo[156]={"Osgiliath after Battle",4,6}
	mapInfo[157]={"Minas Tirith after Battle",4,6}

statusDisplay=Turbine.UI.Lotro.Window();
statusDisplay:SetZOrder(3)
statusDisplay:SetSize(400,100);
statusDisplay:SetPosition((Turbine.UI.Display:GetWidth() - statusDisplay:GetWidth())/2,(Turbine.UI.Display:GetHeight() - statusDisplay:GetHeight())/2)
statusDisplay:SetText("TerrainMap Search");
statusDisplay.Status="Loading";
statusDisplay.StatusText=Turbine.UI.Label();
statusDisplay.StatusText:SetParent(statusDisplay);
statusDisplay.StatusText:SetSize(200,18);
statusDisplay.StatusText:SetPosition((statusDisplay:GetWidth()-statusDisplay.StatusText:GetWidth())/2,40);
statusDisplay.StatusText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
statusDisplay.StatusText:SetText(statusDisplay.Status);

statusDisplay.MapText=Turbine.UI.Label();
statusDisplay.MapText:SetParent(statusDisplay);
statusDisplay.MapText:SetSize(200,18);
statusDisplay.MapText:SetPosition((statusDisplay:GetWidth()-statusDisplay.MapText:GetWidth())/2,60);
statusDisplay.MapText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

statusDisplay:SetWantsUpdates(true);
statusDisplay.MapIndex=1;
statusDisplay.WorldIndex=0;

statusDisplay.Update=function()
	if (Plugins["TMSearch"] ~= nil) and statusDisplay.Status=="Loading" then
		statusDisplay.Status="Initializing";
		Plugins["TMSearch"].Unload = function(statusDisplay,sender,args)
			-- remove the "0TMR_" commands and the "0TMC" command
			for k,v in pairs(respCmd) do
				Turbine.Shell.RemoveCommand(v)
			end
			-- clean up last set of annotations
			_G.tmpAnnotations=nil
		end
	elseif statusDisplay.Status=="Initializing" then
		statusDisplay.Status="Searching"
	elseif statusDisplay.Status=="Searching" then
		if statusDisplay.MapIndex>#mapInfo then
			statusDisplay.Status="Done"
			statusDisplay.MapText:SetText("");
		else
			statusDisplay.MapText:SetText(mapInfo[statusDisplay.MapIndex][1]);
			ProcessMap();
			statusDisplay.MapIndex=statusDisplay.MapIndex+1
		end
	elseif statusDisplay.Status=="Done" then
		statusDisplay:SetWantsUpdates(false);
-- trigger our unload by registering the command "0TMC"
		cmdCount=cmdCount+1
		respCmd[cmdCount]=Turbine.ShellCommand();
		Turbine.Shell.AddCommand("0TMC",respCmd[cmdCount]);
	end		
	statusDisplay.StatusText:SetText(statusDisplay.Status);
end


function ProcessMap()
	local result,error;
	local success,retval;
	result,error=loadstring("import \"GaranStuff.TerrainMap.Data.MapData_"..statusDisplay.MapIndex.."\"");
	if result==nil then
		Turbine.Shell.WriteLine("Error:"..tostring(error));
	else
		-- we may not have a data file for all maps (some have no annotations)
		success,retval=pcall(result);
		if success then
			for k,v in ipairs(_G.tmpAnnotations) do
				if string.find(string.lower(string.stripaccent(_G.tmpMapString[1][v[6]])),searchName)~=nil then
					local tmpStr=string.split(tmpMapString[1][v[6]],":")
					cmdCount=cmdCount+1
					respCmd[cmdCount]=Turbine.ShellCommand();
					if tmpStr[1]~=nil then
						tmpStr[1]=string.gsub(tmpStr[1],",","\194\184")
					end
					if tmpStr[2]~=nil then
						tmpStr[2]=string.gsub(tmpStr[2],",","\194\184")
					end
					if mapInfo[statusDisplay.MapIndex][4]==nil then
						Turbine.Shell.AddCommand("0TMR_"..tostring(cmdCount).."_"..tostring(mapInfo[statusDisplay.MapIndex][2]).."_"..tostring(v[2]).."_"..tostring(v[3]).."_"..tostring(tmpStr[1]).."_"..tostring(mapInfo[statusDisplay.MapIndex][1]).."_"..tostring(mapInfo[statusDisplay.MapIndex][3]).."_"..tostring(tmpStr[2]),respCmd[cmdCount]);
					else
						Turbine.Shell.AddCommand("0TMR_"..tostring(cmdCount).."_"..tostring(mapInfo[statusDisplay.MapIndex][2]).."_"..tostring(mapInfo[statusDisplay.MapIndex][4]).."_"..tostring(mapInfo[statusDisplay.MapIndex][5]).."_"..tostring(tmpStr[1]).."_"..tostring(mapInfo[statusDisplay.MapIndex][1]).."_"..tostring(mapInfo[statusDisplay.MapIndex][3]).."_"..tostring(tmpStr[2]),respCmd[cmdCount]);
					end
				end
			end
			return retval;
		else
--			Turbine.Shell.WriteLine("Error:"..tostring(retval))
			return nil;
		end
	end
end

statusDisplay:SetZOrder(statusDisplay:GetZOrder()+1);
statusDisplay:SetVisible(true);